; Timer  F-A-1  V1.0
; Timer    
;    ..
; 26  2011 
;  RCdesign.r
; :      
;*************************  , , , etc. 
;  B0 - 
;  B1 -   
;  B2 -      
;  B3 -  1   
;  B4 -  
.equ	Val_Akk		=168	; ValAkk= 256/5V * 3.3v
.equ	Val_Time	=120 	;       
.equ	Val_Time2	=Val_Time+5 	;   + 
.equ	PinAct		=1	;   
.equ	PinLed		=0	;  
.equ	PinServ		=2	;    
.equ	PinClock	=3	;   1
.equ	PinADC		=4	;  
.def	v11	=r1	;   
.def	v12	=r2		 
.def	v21	=r3		 
.def	v22	=r4		 
.def	temp	=r16		 
.def	temp1	=r17		 
.def	temp2	=r18		 
.def	temp3	=r19 
.def	Cnt	=r20	;  	 
.def	Cnt2	=r21 
.def	fl_time	=r22	;   , 120+5  -  	 
.def	fl_stop	=r23	;   , 1 -  
			; 1-  ,
			;    -  	 
.def	fl_fly	=r24	;   , 1 -   
.def	fl_akk	=r25	;   , 1 -  ok 
.def	ADC_L	=r26	;  
.def	ADC_H	=r27	;    
.def	Cnt_TL	=r28	;  	 
.def	Cnt_Time=r29	;   	 
.def	ADCreg	=r30	;  
.include "tn13def.inc"
;.include "tn45def.inc"
.eseg
.cseg
.org $0000
		rjmp	start		 	
.org INT0addr
		reti			 
;               Stack Pointer Setup Code 
Start:		ldi temp,low(RAMEND)
		out SPL,temp	
               ; ******* Port B Setup Code ****  
		ldi	temp,$05	; 0,2 - , 1,3 - 
		out 	DDRB,temp	 
		ldi 	temp,$ff	; Init value 
		out 	PORTB,temp	; Port B value

		ldi	temp,$00	;  
		out	GIMSK,temp

 		ldi	Cnt_TL,Val_Time	;     
		ldi 	fl_time,1	;     

Start1:	
		clr	fl_stop		;    
		clr	fl_fly		;    
		rcall	Del_500		;  1 
 		rcall	Del_500
 		rcall   D_Blink		;  
		rcall	Del_500
 		rcall	Del_500
 		rcall 	GetVolt 	;  
		ldi	Cnt,50		; 1    
St_sr_1:	rcall	Pulse1ms	;   1
		rcall	del_20
		dec	Cnt
		brne	St_sr_1
 		clr	Cnt		;    20  
Loop:		
		cpi	fl_fly,1	;   ?
		breq	Start_fly	;    
		cpi	fl_stop,0	;      ?
		breq	Wait_stop_b	;    
		cpi	fl_stop,1	;   
		rjmp	Wait_fly	;     
Wait_stop_b:	rjmp	Wait_stop

Start_fly:				
		rcall	Pulse1ms	;     1  
		
		clr	v11
		clr	v12
		clr	v21
		clr	v22
;		sbic	PinB,PinAct	;     
;		inc	v11
		sbis	PinB,PinClock	;     
		inc	v21
		rcall	del_20fly	;  20 
; 		sbic	PinB,PinAct
;		inc	v12
		sbis	PinB,PinClock
		inc	v22
;		cp	v11,v12
;		brne	St_fl_01
;		tst	v11
;		breq	St_fl_01
;		rjmp	Stop_Fly	;  ,  
St_fl_01:	cp	v21,v22
		brne	St_fl_02
		tst	v21
		breq	St_fl_02
		rjmp 	Stop_fly	;  Clock,  
St_fl_02: 
 		inc	Cnt
		cpi	Cnt,43		;  
		brne	St_fl_03
		cbi	PortB,PinLed
		rjmp	St_fl_end
St_fl_03:	cpi	Cnt,48		; 
		brne	St_fl_04
		sbi	PortB,PinLed
		rjmp	St_fl_end
St_fl_04:	cpi	Cnt,50		; 50   
		brne	St_fl_end
 		clr	Cnt
 		dec	Cnt_time	;   
 		breq	Free_servo	; , 
		rjmp	St_fl_end   
St_fl_end:	rjmp	Start_fly		
;******************************* 
Stop_fly:	rcall	D_Blink		;  
		rcall	del_500
		rjmp	Start1
;********************************
Free_servo:
;  ,    2 
		ldi	Cnt,50		; 1    
Fr_sr_1:	rcall	Pulse2ms	;   2
		rcall	del_20
		dec	Cnt
		brne	Fr_sr_1

 		rcall	del_500 	;   5 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
 		rcall	del_500 
;     1    
		ldi	Cnt,50		; 1    
Fr_sr_2:	rcall	Pulse1ms
		rcall	del_20
		dec	Cnt
		brne	Fr_sr_2
 		rjmp	Start1
;*********************************
;     
;   
Wait_stop:
		clr	v11
		clr	v12
		clr	v21
		clr	v22
		sbic	PinB,PinAct	;   
		inc	v11
		sbis	PinB,PinClock	;  
		inc	v21
 		rcall 	GetVolt		;   
  		ldi	fl_akk,1	;  
		cpi	ADC_H,Val_Akk	;   
		brsh	Wt_s1
 		ldi	fl_akk,0	;  
Wt_s1:
 		sbic	PinB,PinAct	;  
		inc	v12
		sbis	PinB,PinClock	; 
		inc	v22
		cp	v11,v12
		brne	Wt_st_01
		tst	v11
		breq	Wt_st_01
		rjmp	Stop_On		;  
Wt_st_01:	cp	v21,v22
		brne	Wt_st_02
		tst	v21
		breq	Wt_st_02
		rjmp 	Clock_On	;   Clock
Wt_st_02: 
		cpi	fl_akk,1
		breq	Wt_st_03a
		rcall	Blink1_11	;  
		rjmp	Wt_st_end
Wt_st_03a:	cpi	fl_time,1
		brne	Wt_st_03
		rcall	Blink2_12	;   - 
		rjmp	Wt_st_end
Wt_st_03:	cpi	fl_stop,0
		brne	Wt_st_end
		rcall 	Blink2_12	;   - 
		rjmp 	Wt_st_end		
Wt_st_end:	rjmp	Loop_end		
; ********************************* 
;   
;    
Wait_Fly:
;    
		rcall	Pulse1ms
		clr	v11
		clr	v12
		clr	v21
		clr	v22
		sbis	PinB,PinAct
		inc	v11
		sbis	PinB,PinClock
		inc	v21
 		rcall 	GetVolt		;  	
 		ldi	fl_akk,1
		cpi	ADC_H,Val_Akk	;   
		brsh	Wt_f1
 		ldi	fl_akk,0	;  
Wt_f1:
		sbis	PinB,PinAct
		inc	v12
		sbis	PinB,PinClock
		inc	v22
		cp	v11,v12
		brne	Wt_fl_01
		tst	v11
		breq	Wt_fl_01
		rjmp	Fly_On		;  
Wt_fl_01:	cp	v21,v22
		brne	Wt_fl_02
		tst	v21
		breq	Wt_fl_02
		rjmp 	Clock_On	;  Clock
Wt_fl_02: 
		cpi	fl_akk,1	;  ?
		breq	Wt_fl_03a
		rcall	Blink1_11
		rjmp	Wt_fl_end
Wt_fl_03a:	cpi	fl_time,1	;   2 ?
		breq	Wt_fl_03
		rcall	Blink2_12
		rjmp	Wt_fl_end
Wt_fl_03:
		rcall 	Blink2_11
		rjmp 	Wt_fl_end		
Wt_fl_end:	rjmp	Loop_end		
;**********************************
Clock_On:	rcall	Clock_Count	;   
 		clr	Cnt
		rjmp	Loop_end		
;**********************************
Stop_On:	ldi	fl_stop,1	; .   
		clr	Cnt
 		rcall	del_500
		rcall	del_500
		rjmp	Loop_end		
;**********************************
Fly_On:		ldi	fl_fly,1	;    
		clr	Cnt
		mov	Cnt_Time,Cnt_TL	;  
 		rjmp	Loop_end		
Loop_end:
		rjmp	Loop
;***********************************
Blink2_12:	inc	Cnt		;     
		cpi	Cnt,1
		brne	Bk2_12_2
		cbi	PortB,PinLed
		rjmp	Blink2_12_end
Bk2_12_2:	cpi	Cnt,10
		brne	Bk2_12_3
		sbi	PortB,PinLed
		rjmp	Blink2_12_end
Bk2_12_3:	cpi	Cnt,115
		brne	Bk2_12_4
		cbi	PortB,PinLed
		rjmp	Blink2_12_end
Bk2_12_4:	cpi	Cnt,125
		brne	Bk2_12_5
		sbi	PortB,PinLed
		rjmp	Blink2_12_end
Bk2_12_5:	cpi	Cnt,135
		brne	Bk2_12_6
		cbi	PortB,PinLed
		rjmp	Blink2_12_end
Bk2_12_6:	cpi	Cnt,145
		brne	Bk2_12_7
		sbi	PortB,PinLed
		rjmp	Blink2_12_end
Bk2_12_7:	cpi	Cnt,250
		brne	Blink2_12_end
 		clr	Cnt
		rjmp	Blink2_12_end
Blink2_12_end:  ret

Blink2_11:	inc	Cnt		;   
		cpi	Cnt,1
		brne	Bk2_11_2
		cbi	PortB,PinLed
		rjmp	Bk2_11_end
Bk2_11_2:	cpi	Cnt,95
		brne	Bk2_11_3
		sbi	PortB,PinLed
		rjmp	Bk2_11_end
Bk2_11_3:	cpi	Cnt,100
		brne	Bk2_11_4
		cbi	PortB,PinLed
		rjmp	Bk2_11_end
Bk2_11_4:	cpi	Cnt,195
		brne	Bk2_11_5
		sbi	PortB,PinLed
		rjmp	Bk2_11_end
Bk2_11_5:	cpi	Cnt,200
		brne	Bk2_11_end
		clr	Cnt
		rjmp	Bk2_11_end
Bk2_11_end:     ret


Blink1_11:	inc	Cnt		;  
		cpi	Cnt,1
		brne	Bk1_11_2
		cbi	PortB,PinLed
		rjmp	Blink1_11_end
Bk1_11_2:	cpi	Cnt,15
		brne	Bk1_11_3
		sbi	PortB,PinLed
		rjmp	Blink1_11_end
Bk1_11_3:	cpi	Cnt,20
		brne	Bk1_11_4
		cbi	PortB,PinLed
		rjmp	Blink1_11_end
Bk1_11_4:	cpi	Cnt,35
		brne	Bk1_11_5
		sbi	PortB,PinLed
		rjmp	Blink1_11_end
Bk1_11_5:	cpi	Cnt,40
		brne	Blink1_11_end
		clr	Cnt
		rjmp	Blink1_11_end
Blink1_11_end:  ret

Clock_Count:	push	temp1		;   
		push	temp2
		push	temp3
		rcall 	d_blink
 		clr	temp1
		clr	temp2
		clr	temp3
Clock_1: 
 		rcall	del_20cnt
		sbis 	pinb,pinclock
		rjmp	Clock_end
		inc	temp3
		cpi	temp3,40
		brne	Clock_2
		cbi	PortB,PinLed
		rjmp	Clock_5
Clock_2:	cpi	temp3,50
		brne	Clock_5
		sbi	PortB,PinLed
Clock_3:	clr	temp3
		inc 	temp1
 		breq	Clock_err
Clock_5:	rjmp	Clock_1
Clock_err:	rcall	d_blink
		rcall	d_blink
		rcall	del_500
		rjmp	Clock_ret
Clock_end: 	tst 	temp1
		breq	Clock_err
 		mov	Cnt_Tl,temp1
		ldi	fl_time,0
		cpi 	Cnt_Tl,Val_Time
		brlo	Clock_6
		cpi	Cnt_Tl,Val_Time2
		brsh	Clock_6
		ldi	fl_time,1
Clock_6:	
		rcall 	D_Blink
		rcall 	del_500
Clock_ret:	pop	temp3
		pop	temp2
		pop	temp1
		ret
  
 
		
; \   1 
Pulse1ms:	push 	temp1
		push  	temp2
		sbi	PortB,2		;  
		rcall	Del_1		;  
		cbi	PortB,2		;  
 		pop   	temp1
		pop	temp2
		ret
; \   2 
Pulse2ms:	push 	temp1
		push  	temp2
		sbi	PortB,2		;  
		rcall	Del_2		;  
		cbi	PortB,2		;  
 		pop   	temp1
		pop	temp2
		ret
Blink:     	rcall del_100		; \  
 		cbi portb,0
 		rcall del_100
 		rcall del_100
 		rcall del_100
 		sbi portb,0
 		rcall del_100
		ret  
D_Blink:       	rcall del_100		; \  
 		cbi portb,0
 		rcall del_100
 		sbi portb,0
 		rcall del_100
 		cbi portb,0
 		rcall del_100
 		sbi portb,0
 		rcall del_100
		ret  
 
 
del_500:	push 	temp1
		push 	temp2
		push 	temp3
		ldi 	temp3,179	; 
lp1:		ldi 	temp2,30	; 500  (0.5 )
lp2:		ldi 	temp1,30
lp3:		dec 	temp1
		brne 	lp3
		dec 	temp2
		brne 	lp2
		dec 	temp3
		brne 	lp1
		pop	temp3
		pop	temp2
		pop	temp1
		ret
	
del_100:	push temp2
		push temp1	; 
		ldi temp2,221	; 100  (0.1 )
ls2:		ldi temp1,150
ls1:		dec temp1
		brne ls1
		dec temp2
		brne ls2
		pop temp1
		pop temp2
		ret
del_1: 		push temp2
		push temp1	; 
		ldi temp2,83	; 1  (0.001 )
lm2:		ldi temp1,3
lm1:		dec temp1
		brne lm1
		dec temp2
		brne lm2
		pop temp1
		pop temp2
		ret
del_2:		push temp2
		push temp1	; 
		ldi temp2,83	; 2  (0.002 )
lz2:		ldi temp1,8
lz1:		dec temp1
		brne lz1
		dec temp2
		brne lz2
		pop temp1
		pop temp2
		ret
del_20:		push temp2
		push temp1	; 
		ldi temp2,221	; 20  (0.02 )
ln2:		ldi temp1,30
ln1:		dec temp1
		brne ln1
		dec temp2
		brne ln2
		pop temp1
		pop temp2
		ret
del_20cnt:	push temp2	;   
		push temp1	; 
		ldi temp2,240	; 20  (0.02 )
lc2:		ldi temp1,30
lc1:		dec temp1
		brne lc1
		dec temp2
		brne lc2
		pop temp1
		pop temp2
		ret
del_20fly:	push temp2	;    
		push temp1	; 
		ldi temp2,230	; 20  (0.02 )
lf2:		ldi temp1,30
lf1:		dec temp1
		brne lf1
		dec temp2
		brne lf2
		pop temp1
		pop temp2
		ret
GetVolt: 	;    
 		ldi 	ADCreg,(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0)
       		out   	ADCSRA,ADCreg       ;  ,    64
       		ldi   	ADCreg,0b00000000
       		out   	ADCSRB,ADCreg       ;   
   		ldi 	ADCreg,(0<<REFS0)|(1<<ADLAR)|(1<<MUX1)|(0<<MUX0)
       		out   	ADMUX,ADCreg         
 		ldi 	ADCreg,(1<<PinADC)
       		out   	DIDR0,ADCreg
        	sbi   	ADCSRA,ADSC      ;   
		rcall	del_20
Wt_k0:  	sbic  	ADCSRA,ADSC      ;  (ADCSRA & (1<<ADSC))
        	rjmp  	Wt_k0
        	in	ADC_L,ADCL
 	      	in   	ADC_H,ADCH       ;    
ret
 
